#line 1 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
#line 125 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
unsigned char NbCarPL;
unsigned char LCD_ADR ;
unsigned char addr;





sbit LD1 at LATD4_bit;
sbit LD2 at LATE4_bit;
sbit LD1_Direction at TRISD4_bit;
sbit LD2_Direction at TRISE4_bit;

sbit RE6_FAULT at RE6_bit;
sbit RE5_SENSEL at LATE5_bit;
sbit RJ5_Stat at RJ5_bit;
sbit RF6_VSENSE at RF6_bit;

sbit Led_Rouge at LATD4_bit;
sbit Led_Rouge_Directiont at TRISD4_bit;

sbit BP1 at RD7_bit;
sbit BP2 at RH3_bit;
sbit BP1_Direction at TRISD7_bit;
sbit BP2_Direction at TRISH3_bit;

sbit PPS at RB1_bit;
sbit PPS_Direction at TRISB1_bit;

sbit Horaire_Ete at RA2_bit;
sbit Horaire_Ete_Direction at TRISA2_bit;
#line 167 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
const char chaine0[]="Projet : " "Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD2119_1609.mcppi" "\r\n";
const char chaine1[]="FOSC=48MHZ  PLL active  \r\n";
const char chaine2[]="UART1 19200 <--- prolifix-> Terminal PC \r\n";
const char chaine3[]="UART2 19200  <--> GPS UBLOX 7N\r\n ";
const char chaine4[]="PORT USB HID Terminal \r\n";
const char *RS_Str[]={chaine0,chaine1,chaine2,chaine3,chaine4};


unsigned char buffer1[ 512 ];
unsigned int Index1,i1;
unsigned int UART1_DataReady;
unsigned char c1;



unsigned char buffer2[ 512 ];
unsigned int Index2,i2;
unsigned int UART2_DataReady;
unsigned char c2;


char TEXTE[128];
char CRam1[40];
char *txt;
unsigned int i,j,k;
unsigned char dummy;
double f1,f2;

unsigned int Flag_Timer0;
unsigned int Cpt0;
unsigned int EAx,EA0,EA1;
unsigned long Fr;
int Terminator=13;

volatile unsigned int Elapsed_Tmr3;
volatile int Cnt3=100;


unsigned Cnt;
unsigned Sec;
unsigned Minute;
unsigned Hour;
unsigned char SecS[7];
unsigned char MinuteS[7];
unsigned char HourS[7];


unsigned char Heure_GPS[17];
float lat,lon,lon_dec,lat_dec,alt,alt_dec,rem,Speed;
int Flag_GPS=0;
unsigned char Latitude[11], Longitude[16],Altitude[16];
unsigned char Knot_Speed[16];
unsigned char Satellites[4];
unsigned char Utc[12];
unsigned char HDOP[8];
unsigned char NSid, EWid, GPSFIX;
char *p1;
unsigned char Trame_GGA[128];
unsigned char Trame_RMC[128];
unsigned char Date[9]="01/01/16";
unsigned int JJ,MM,AA;
long LDate=0;



struct chbits {
 unsigned Stable:1;
 unsigned SDcard:1;
 unsigned elligible:1;
 unsigned Accumule:1;
 unsigned Blc:1;
 unsigned Over:1;
 unsigned Fill:1;
 unsigned Lcd:1;
 } Drapeaux;



void UART3_Write(unsigned char cc);
void UART3_Write_Text(unsigned char *T);
void strConstRamCpy(char *dest, const char *source);
int Decode_Trame_GPS(void);
unsigned int BT_Configure_With_Answer_Test();
void Display_Trame_on_Terminal(void);
void Display_Trame_On_LCD (void);

 void Interrupts() iv 0x0008 ics ICS_AUTO
{

 if((RC1IF_bit==1) && (RC1IE_bit==1))
 {
 if(OERR1_bit)
 {
 CREN1_bit = 0;
 CREN1_bit = 1;
 OERR1_bit = 0;
 }
 if(FERR1_bit) c1 = RCREG1;
 c1 = RCREG1;

 if ((c1== 13 )|| (i1>= 512 ))
 {
 UART1_DataReady=1;
 if (i1 >= 512 ) UART1_DataReady=2;
 PIE2.RC1IE=0 ;
 buffer1[i1]=0;
 Index1=i1;
 i1=0;
 c1=0;
 }
 else
 {
 buffer1[i1]=c1;
 Index1=i1;
 i1++;
 }
 }

 if((RC2IF_bit==1) && (RC2IE_bit==1))
 {
 if(OERR2_bit)
 {
 CREN2_bit = 0;
 CREN2_bit = 1;
 }
 if(FERR2_bit) c2 = RCREG2;
 c2 = RCREG2;


 if((i2>= 512 -1) || (c2==13))
 {
 Index2=i2;

 while(RC2IF_bit==0);
 c2=RCREG2;
 c2=0;
 if (UART2_DataReady==0)Trame_RMC[i2]=c2;
 if (UART2_DataReady==1)Trame_GGA[i2]=c2;
 i2=0;
 UART2_DataReady++;
 if (UART2_DataReady==2)
 {
 c2=RCREG2;
 c2=0;
 RC2IE_bit=0 ;
 }

 }
 else
 {
 if (UART2_DataReady==0)Trame_RMC[i2]=c2;
 if (UART2_DataReady==1)Trame_GGA[i2]=c2;
 Index2=i2;
 i2++;
 }


 }
#line 358 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
}


 void Interrupt_Timer3() iv 0x0018 ics ICS_AUTO
{
 if ((PIE2.TMR3IE==1) && (PIR2.TMR3IF==1))
 {
 Cnt3--;
 TMR3H = 0x15;
 TMR3L = 0xA0;
 if (Cnt3 <=0 )
 {
 Elapsed_Tmr3=1;
 T3CON.TMR3ON=0;
 PIE2.TMR3IE=0;
 }

 TMR3IF_bit = 0;
 PIR2.TMR3IF=0;
 }
}
#line 1 "c:/_mikroc/_mesprojets_mikroc/_18f87j50_gps/lcd2119_i2cx_routines.inc"
#line 19 "c:/_mikroc/_mesprojets_mikroc/_18f87j50_gps/lcd2119_i2cx_routines.inc"
extern int j;
extern int k;
extern char *txt;

extern unsigned char NbCarPL;
extern unsigned char LCD_ADR ;
#line 57 "c:/_mikroc/_mesprojets_mikroc/_18f87j50_gps/lcd2119_i2cx_routines.inc"
sbit Soft_I2C_Scl at RD6_bit;
sbit Soft_I2C_Sda at RD5_bit;
sbit Soft_I2C_Scl_Direction at TRISD6_bit;
sbit Soft_I2C_Sda_Direction at TRISD5_bit;
#line 70 "c:/_mikroc/_mesprojets_mikroc/_18f87j50_gps/lcd2119_i2cx_routines.inc"
extern void UART1_Write_CText(const char *txt1);
extern void CRLF1(void);





void LCD_CLS(void);
void LCD_Clear(void);
int LCD2119_Init(void);
void LCD_RAZ_Ligne(int L);
void LCD_Write_Chr_At(int Ligne,int Col,char c1) ;
void LCD_Write_Text_At(unsigned int Ligne,unsigned int col,char * t1);
void LCD_Write_CText_At(unsigned int Ligne,unsigned int col,const char * t1);
void LCD_Write_CText(const char * t1);
void Cree_Euro(void) ;
void Cree_8_cars_CGRAM(void) ;
void LCD_Cde(unsigned char Cde);
void LCD_Gauche(void);
void LCD_Droite(void);


void LCD_CLS()
{

LCD_RAZ_Ligne(2);
LCD_RAZ_Ligne(1);
}

void LCD_Clear()
{

int j;
 I2C2_Start ();
j= I2C2_Wr (LCD_ADR);
j= I2C2_Wr (0x00);
j= I2C2_Wr (0x24);
j= I2C2_Wr (0x06);
j= I2C2_Wr (0x02);
j= I2C2_Wr (0x01);
j= I2C2_Wr (0x40);
 I2C2_Stop ();
}

int LCD2119_Init(void)
{

int j,k;
k=0;
Delay_ms(500);
 I2C2_Start ();
j= I2C2_Wr (LCD_ADR);
if (j!=0) return k;
k++;
Delay_ms(200);
j= I2C2_Wr (0x00);
if (j>0) return k;
k++;
 I2C2_Wr (0x24);
 I2C2_Wr (0x0C);
 I2C2_Wr (0x06);
 I2C2_Wr (0x25);

 I2C2_Wr (0x06);
 I2C2_Wr (0x11);
 I2C2_Wr (0x42);

 I2C2_Wr (0x96);
j= I2C2_Wr (0x24);
if (j>0) return k;
k++;
j= I2C2_Wr (0x0C);
if (j>0) return k;
k++;
j= I2C2_Wr (0x06);
if (j>0) return k;
k++;
j= I2C2_Wr (0x02);
if (j>0) return k;
k++;


j= I2C2_Wr (0x01);
if (j>0) return k;
Delay_ms(100);
 I2C2_Stop ();
k++;
return k;
}

void LCD_RAZ_Ligne( int L)
{
int i;
  I2C2_Start ();
  I2C2_Wr (LCD_ADR);
  I2C2_Wr (0x00);
  I2C2_Wr (0x02);
 switch (L)
 {
 case 1:
  I2C2_Wr (0x80);
 break;
 case 2:
  I2C2_Wr (0xC0);
 break;
 default:
 break ;
 }
  I2C2_Repeated_Start ();
  I2C2_Wr (LCD_ADR);
  I2C2_Wr (0x40);
 for (i=0;i<NbCarPL;i++)
 {
  I2C2_Wr (0x80+32);
 }

  I2C2_Repeated_Start ();
  I2C2_Wr (LCD_ADR);
  I2C2_Wr (0x00);

 switch (L)
 {
 case 1:
  I2C2_Wr (0x80);
 break;
 case 2:
  I2C2_Wr (0xC0);
 break;
 default:
 break ;
 }
  I2C2_Stop ();
}

void LCD_Write_CText(const char * t1)
 {
 char TT[21];
 int i;
 strConstRamCpy(TT,t1);
  I2C2_Start ();
  I2C2_Wr (LCD_ADR);
  I2C2_Wr (0x00);
  I2C2_Repeated_Start ();
  I2C2_Wr (LCD_ADR);
  I2C2_Wr (0x40);
 i=0;
 while(*(t1))
 {
  I2C2_Wr (0x80+*(t1));
 t1++;
 i++;

 }
  I2C2_Stop ();
}

void LCD_Write_CText_At(unsigned int Ligne,unsigned int col,const char * t1)
 {
 char TT[21];
 int i;
 strConstRamCpy(TT,t1);
  I2C2_Start ();
  I2C2_Wr (LCD_ADR);
  I2C2_Wr (0x00);
 if(col>NbCarPL) col=NbCarPL;
 switch (Ligne)
 {
 case 1:
  I2C2_Wr (0x80+col-1);
 break;
 case 2:
  I2C2_Wr (0xc0+col-1);
 break;
 default:
 break ;
 }
  I2C2_Repeated_Start ();
  I2C2_Wr (LCD_ADR);
  I2C2_Wr (0x40);
 i=col;
 while(*(t1))
 {
  I2C2_Wr (0x80+*(t1));
 t1++;
 i++;
 if (i>NbCarPL) break;
 }
  I2C2_Stop ();
}

void LCD_Write_Chr_At(int Ligne,int col,char c1)
{


  I2C2_Start () ;
  I2C2_Wr (LCD_ADR);
  I2C2_Wr (0x00);
 if(col>NbCarPL) col= NbCarPL;
 switch (Ligne)
 {
 case 1:
  I2C2_Wr (0x80+col-1);
 break;
 case 2:
  I2C2_Wr (0xc0+col-1);
 break;
 default:
 break ;
 }
  I2C2_Repeated_Start () ;
  I2C2_Wr (LCD_ADR);
  I2C2_Wr (0x40);
  I2C2_Wr (0x80+c1);
  I2C2_Stop ();
 }

void LCD_Write_Text_At(unsigned int Ligne,unsigned int col,char * t1)
{

 int i;
  I2C2_Start ();
  I2C2_Wr (LCD_ADR);
  I2C2_Wr (0x00);
 if(col>NbCarPL) col=NbCarPL;
 switch (Ligne)
 {
 case 1:
  I2C2_Wr (0x80+col-1);
 break;
 case 2:
  I2C2_Wr (0xc0+col-1);
 break;
 default:
 break ;
 }
  I2C2_Repeated_Start ();
  I2C2_Wr (LCD_ADR);
  I2C2_Wr (0x40);
 i=col;
 while(*(t1))
 {
  I2C2_Wr (0x80+*(t1));
 t1++;
 i++;
 if (i>NbCarPL) break;
 }
  I2C2_Stop ();
}

void LCD_Home()
{
 LCD_Cde(0x02);
}


void LCD_Droite()
{
 LCD_Cde(0x014);
 }

void LCD_Cde(unsigned char Cde)
{
  I2C2_Start ();
  I2C2_Wr (0x76);
  I2C2_Wr (0x00);
  I2C2_Wr (Cde);
  I2C2_Stop ();
}

void LCD_Gauche()
{
 LCD_Cde(0x010);
 }

void Cree_8_cars_CGRAM()
{
int i,j;
unsigned char b1,b2;
  I2C2_Start ();
  I2C2_Wr (LCD_ADR);
  I2C2_Wr (0x00);

  I2C2_Wr (0x40);

  I2C2_Repeated_Start () ;
  I2C2_Wr (LCD_ADR);
  I2C2_Wr (0x40);


 I2C2_Wr (0b0000000);
 I2C2_Wr (0b0000000);
 I2C2_Wr (0b0000000);
 I2C2_Wr (0b0000000);
 I2C2_Wr (0b0000000);
 I2C2_Wr (0b0000000);
 I2C2_Wr (0b0000000);
 I2C2_Wr (0b0000000);
 b2=32;
 b1=0;
 for (i=0;i<5;i++)
 {
 b2=b2>>1;
 b1=b1+b2;
 for (j=0;j<8;j++)
 {





  I2C2_Wr (b1);

 }



 }

 I2C2_Wr (0b0000000);
 I2C2_Wr (0b0000000);
 I2C2_Wr (0b0011111);
 I2C2_Wr (0b0010001);
 I2C2_Wr (0b0011111);
 I2C2_Wr (0b0000000);
 I2C2_Wr (0b0000000);
 I2C2_Wr (0b0000000);


 I2C2_Wr (0x06);
 I2C2_Wr (0x09);
 I2C2_Wr (0x08);
 I2C2_Wr (0x1E);
 I2C2_Wr (0x1E);
 I2C2_Wr (0x08);
 I2C2_Wr (0x09);
 I2C2_Wr (0x06);
 I2C2_Stop ();
}


void Cree_Euro()
{
 I2C2_Start ();

 I2C2_Wr (LCD_ADR);


 I2C2_Wr (0x00);


 I2C2_Wr (0x06);


 I2C2_Wr (0x40);


  I2C2_Repeated_Start () ;
 I2C2_Wr (LCD_ADR);

 I2C2_Wr (0x40);



 I2C2_Wr (0x06);
 I2C2_Wr (0x09);
 I2C2_Wr (0x08);
 I2C2_Wr (0x1E);
 I2C2_Wr (0x1E);
 I2C2_Wr (0x08);
 I2C2_Wr (0x09);
 I2C2_Wr (0x06);
 I2C2_Stop ();
}


unsigned char check_device(unsigned char dev_address)
{
char Etat;
char Sortie[9];



UART1_Write_CText("Check Device @ ");
ByteToStr(dev_address,Sortie);
UART1_Write_Text(Sortie);
UART1_Write_CText(" on I2C");

UART1_Write_CText("2  HARDW");
#line 469 "c:/_mikroc/_mesprojets_mikroc/_18f87j50_gps/lcd2119_i2cx_routines.inc"
 I2C2_Start ();
Etat=  I2C2_Wr (dev_address);
if(Etat!=0 )
 {
 UART1_Write_CText(" is not found");
 Etat=0;
 }
 else
 {
 UART1_Write_CText(" found OK");
 Etat=1;
 }
  I2C2_Stop ();
 CRLF1();
 return Etat;
}



void Decompile_byte(unsigned char un)
{
 unsigned char masque;
 masque = 0x80;
 while (masque > 0u )
 {
 if ((un & masque)>0)
 UART1_Write(49u);
 else
 UART1_Write(48u);
 masque =masque >>1;
 }
}
#line 439 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 unsigned char strcmp_P(char *ram_str, const char *rom_str){
 char diff,c;
 while((c = *rom_str++)){
 diff = *ram_str++ - c;
 if(diff)
 return diff;
 }
 return 0;
}




void RAZ_UART1()
{

 for(i1=0;i1< 512 ;i1++) buffer1[i1]=0;
 Index1=0;
 i1=0;
 if(RC1IF_bit==1) c1=RCREG1;
 c1=0;
 UART1_DataReady=0;
 PIE2.RC1IE=1 ;
}


void RAZ_UART2()
{
 for(i2=0;i2< 512 ;i2++) buffer2[i2]=0;
 Index2=0;
 i2=0;
 if (RC2IF_bit==1) c2=RCREG2;
 c2=0;
 UART2_DataReady=0;
 RC2IE_bit=1 ;
}
#line 515 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
void Init_ADC()
 {


 ADCON0.VCFG1=0;
 ADCON0.VCFG0=0;
 ADCON0.CHS3=0;
 ADCON0.CHS2=0;
 ADCON0.CHS1=0;
 ADCON0.CHS0=1;
 ADCON0.ADON=1;


 ANCON0=0xFF;
 ANCON0.PCU1=0;

 ADCON1.ADFM=1;
 ADCON1.ADCAL=0;
 ADCON1.ACQT2=1;
 ADCON1.ACQT1=1;
 ADCON1.ACQT0=0;
 ADCON1.ADCS1=1;
 ADCON1.ADCS2=0;
 ADCON1.ADCS0=10;
 }

 void Hardware_Init(void)
 {
 ANCON0=0xFD ;
 ANCON1=0xFF;

 TRISA=0xFF;
 TRISB=0xFF;
 TRISD=0xFF;
 TRISC=0xFF;
 TRISG=0xFF;
 TRISD6_bit=0;

 Horaire_Ete_Direction=1 ;
 BP1_Direction = 1;
 BP2_Direction = 1;
 LD1_Direction = 0;
 LD2_Direction = 0;
 LD1 = 0;
 LD2 = 0;
 PPS_Direction=1;
 }

void Test_2_leds()
{
 LD1 = 0;
 LD2 = 0;
 Delay_ms(500);
 LD1 = 1;
 Delay_ms(500);
 LD1 = 0;
 LD2 = 1;
 Delay_ms(500);
 LD1 = 1;
 LD2 = 0;
 Delay_ms(500);
 LD1 = 0;
 LD2 = 0;
 }



void fltToa (float x, unsigned char *str,char precision)
{


int ie, i, k, ndig;
double y;
ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
ie = 0;

if ( x < 0)
 {
 *str++ = '-';
 x = -x;
 }

if (x > 0.0) while (x < 1.0)
 {
 x *= 10.0;
 ie--;
 }
while (x >= 10.0)
 {
 x = x/10.0;
 ie++;
 }
 ndig += ie;


for (y = i = 1; i < ndig; i++)
 y = y/10.;
x += y/2.;
if (x >= 10.0) {x = 1.0; ie++;}
if (ie<0)
 {
 *str++ = '0'; *str++ = '.';
 if (ndig < 0) ie = ie-ndig;
 for (i = -1; i > ie; i--) *str++ = '0';
 }
for (i=0; i < ndig; i++)
 {
 k = x;
 *str++ = k + '0';
 if (i == ie ) *str++ = '.';
 x -= (y=k);
 x *= 10.0;
 }
*str = '\0';
}

 void UART1_Write_CText(const char *txt1)
 {
 while (*txt1)
 UART1_Write(*txt1++);
}
void UART2_Write_CText(const char *txt2)
 {
 while (*txt2)
 UART2_Write(*txt2++);
}



void strConstRamCpy(char *dest, const char *source) {
 while(*source) *dest++ = *source++ ;
 *dest = 0 ;
}

void CRLF1()
{
 UART1_Write( 13 );
 UART1_Write( 10 );
 }

void CRLF2()
{
 UART2_Write( 13 );
 UART2_Write( 10 );
 }


void Arme_Elapsed_Timer3()
{


 TMR3H = 0x15;
 TMR3L = 0xA0;
 Elapsed_Tmr3=0;

 PIR2.TMR3IF=0;
 PIE2.TMR3IE=1;
 T3CON.TMR3ON=1;
}

 void My_Init_Timer3()
{







 TMR3H=0x15 ;
 TMR3L=0XA0;
 Elapsed_Tmr3=0;
 T3CON.TMR3CS=0;

 T3CON.T3CKPS1=1;
 T3CON.T3CKPS0=1;
 T3CON.T3CCP2 =0;
 T3CON.T3CCP1 =0;

 T3CON.T3SYNC=0;
 T3CON.RD16=1 ;
 T3CON.TMR3ON=0;
 IPR2.TMR3IP =0;
 PIR2.TMR3IF=0;
 PIE2.TMR3IE=0;
}


int Decode_Trame_GPS_GPGGA(void)
 {
 int i, j,k,Pas;
 j = 0;
 Pas=1;
 k=strlen(Trame_GGA) ;
 for (i=7;i<k;i++)
 {
 switch (Pas)
 {
 case 1:
#line 717 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 if(Trame_GGA[i]==',')
 {
 Utc[j]=0;
 j=0;
 Pas=2;
 break;
 }
 else
 {
 Utc[j]=Trame_GGA[i];
 j++;
 }
 break;
 case 2 :
#line 734 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 if(Trame_GGA[i]==',')
 {
 Latitude[j]=0;
 j=0;
 Pas=3;
 break;
 }
 else
 {
 Latitude[j]=Trame_GGA[i];
 j++;
 }
 break;
 case 3 :
#line 751 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 if(Trame_GGA[i]==',')
 {
 j=0;
 Pas=4;
 break;
 }
 else
 {
 NSid=Trame_GGA[i];
 j++;
 }
 break;
 case 4 :
#line 767 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 if(Trame_GGA[i]==',')
 {
 Longitude[j]=0;
 j=0;
 Pas=5;
 break;
 }
 else
 {
 Longitude[j]=Trame_GGA[i];
 j++;
 }
 break;
 case 5 :
#line 784 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 if(Trame_GGA[i]==',')
 {
 j=0;
 Pas=6;
 break;
 }
 else
 {
 EWid=Trame_GGA[i];
 j++;
 }
 break;
 case 6 :
#line 800 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 if(Trame_GGA[i]==',')
 {
 j=0;
 Pas=7;
 break;
 }
 else
 {
 GPSFIX=Trame_GGA[i];
 j++;
 }
 break;
 case 7 :
#line 816 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 if(Trame_GGA[i]==',')
 {
 Satellites[j]=0;
 j=0;
 Pas=8;
 break;
 }
 else
 {
 Satellites[j]=Trame_GGA[i];
 j++;
 }
 break;
 case 8 :
#line 833 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 if(Trame_GGA[i]==',')
 {

 HDOP[j]=0;
 j=0;
 Pas=9;
 break;
 }
 else
 {
 HDOP[j]=Trame_GGA[i];
 j++;
 }
 break;



 case 9 :
#line 854 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 if(Trame_GGA[i]==',')
 {

 Altitude[j]=0;
 j=0;
 Pas=10;
 break;
 }
 else
 {
 Altitude[j]=Trame_GGA[i];
 j++;
 }
 break;

 default:
#line 873 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 i=k;
 break;
 }
 }
 return Pas;
 }

void Display_Trame_On_Terminal()
{
#line 886 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 UART1_Write_CText(" Utc: ");
 UART1_Write(Utc[0]); UART1_Write(Utc[1]);UART1_Write('H');
 UART1_Write(Utc[2]); UART1_Write(Utc[3]);UART1_Write('M');
 UART1_Write(Utc[4]); UART1_Write(Utc[5]);UART1_Write('S');

 UART1_Write_CText("    Lon : ");
 lon= atof(Longitude);
 f1=lon/100.0;
 f1=floor(lon/100.0);
 f2=(lon/100)-f1;
 lon=f1+f2*100/60;
 fltToa (lon,txt,6);
 UART1_Write_Text(txt);
 UART1_Write(' ');UART1_Write(NSid);

 UART1_Write_CText("     Lat : ");

 lat= atof(Latitude);
 f1=lat/100.0;
 f1=floor(lat/100.0);
 f2=(lat/100)-f1;
 lat=f1+f2*100/60;
 fltToa (lat,txt,6);
 UART1_Write_Text(txt);
 UART1_Write(' '); UART1_Write(EWid);

 UART1_Write_CText("     Alt : ");

 alt= atof(Altitude);
 fltToa (alt,txt,1);
 UART1_Write_Text(txt);

 UART1_Write_CText("   Satel: ");
 UART1_Write_Text(Satellites);

 UART1_Write_CText("    HDOP : ");
 UART1_Write_Text(HDOP);

 UART1_Write_CText("    Fix: ");UART1_Write(GPSFIX);
 CRLF1();
}


void Display_Trame_On_LCD ()
{
 int k;
 char HH[3];
 int h;
 LCD_RAZ_Ligne(1);
 strConstRamCpy(CRam1,"Altitud:        ");
 k=6-strlen(Altitude);
 if(k<0)k=0;
 strcpy(CRam1+11-k,Altitude);
 CRam1[15]='m';
 LCD_Write_Text_At(1,1,CRam1);
 LCD_RAZ_Ligne(2);
 strConstRamCpy(CRam1,"UTC:   H  M  S  ");
 memcpy(HH,Utc,2);
 h= atoi(HH)+1;
 if (h>23)h=0;
 h=h +(Horaire_Ete==0);
 k=strlen(Utc);
 ByteToStr((unsigned char)h,HH);
 memcpy(CRam1+5,HH+1,2);
 memcpy(CRam1+8,Utc+2,2);
 memcpy(CRam1+11,Utc+4,2);
 CRam1[16]=0;
 LCD_Write_Text_At(2,1,CRam1);
 Delay_ms(1500);

 strConstRamCpy(CRam1,"LON:            ");
 fltToa (lon,CRam1+5,6);
 while(strlen(CRam1)<16)
 {
 strcat(CRam1," ");
 }
 CRam1[15]=EWid;
 CRam1[16]=0;
 LCD_Write_Text_At(1,1,CRam1);

 strConstRamCpy(CRam1,"LAT:            ");
 fltToa (lat,CRam1+5,6);
 while(strlen(CRam1)<16)
 {
 strcat(CRam1," ");
 }
 CRam1[15]=NSid;
 CRam1[16]=0;
 LCD_Write_Text_At(2,1,CRam1);
 Delay_ms(1500);
 }


 void Recupere_Date_RMC()
 {
 strConstRamCpy(Date,"JJ/MM/AA");
 Date[0]=Trame_RMC[53];
 Date[1]=Trame_RMC[54];
 Date[3]=Trame_RMC[55];
 Date[4]=Trame_RMC[56];
 Date[6]=Trame_RMC[57];
 Date[7]=Trame_RMC[58];
 Date[8]=0 ;
 UART1_Write_CText(" Date RMC= ");
 UART1_Write_Text(Date);
 UART1_Write( 9 );

 JJ=(Trame_RMC[53]-48)*10 + Trame_RMC[54]-48;
 MM=(Trame_RMC[55]-48)*10 + Trame_RMC[56]-48;
 AA=(Trame_RMC[57]-48)*10 + Trame_RMC[58]-48;
 LDate= (long) AA * 100000L + (long) MM* 100 + (long) JJ;
#line 1017 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 CRLF1();


 }



void main()
{
#line 1039 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 OSCCON.IRCF2=1;
 OSCCON.IRCF1=1;
 OSCCON.IRCF0=1;


 OSCCON.SCS1=1;
 OSCCON.SCS0=0;
 OSCTUNE=0;

 OSCTUNE.PLLEN=1;
 while(OSCCON.OSTS==0);


 Hardware_Init();


 Cnt3=100;

 txt=&TEXTE[0];
 TEXTE[0]=0;
 CRam1[0]=0;
#line 1066 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 Delay_ms(5000);

 UART1_Init(38400);
 UART1_Write( 12 );
 Delay_ms(500);
 UART1_Write_CText(" Hardware: \r\n Clicker2 18F87J50 Survivor + GPS-COMPS  UBox 7N\r\n");
 UART1_Write_CText(" Directory :" " C:\_MikroC\_MesProjets_MikroC\_18F87J50_GPS" "\r\n");
 UART1_Write_CText(" Source MikroC " "Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_" "_" "160903" ".c\r\n");
 UART1_Write_CText(" FOSC=8Mhz interne x PLL => 48Mhz  \r\n");
 UART1_Write_CText(" Liaison PIC <-> PC: \r\n");
 UART1_Write_CText(" UART1 38400,8,N,1 Clicker2 Mikrobus#2 RC6,RC7 <- PL2303 - >terminal VBRAY \r\n");
 UART1_Write_CText(" Liaison Module GPS UBLOX 7N: \r\n");
 UART1_Write_CText(" UART2 19200,8,N,1 Clicker2 MikroBus#1 RG1,RG2 <-> GPS UBLOX 7N\r\n");
 UART1_Write_CText(" Decode Trame NMEA GPGGA \r\n");
 Delay_ms(200);

 UART2_Init(19200);
#line 1107 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 I2C2_Init(400000);
 UART1_Write_CText(" Init I2C2 Hardware 400Khz\r\n");

 Cnt3=100;
 My_Init_Timer3();



 LCD_ADR=0x74;
 addr= LCD_ADR;
 NbCarPL= 16;
 UART1_Write_CText(" Check presence LCD2119 at @ 0x74\r\n");
 k=check_device(addr) ;
 CRLF1();
 UART1_Write_CText(" Init LCD 2119 2x16\r\n");
 k=LCD2119_Init();
 Delay_ms(150);
 LCD_CLS();
 Delay_ms(150);
 LCD_Write_CText_At(1,1,"Init Timer3 40mS");
 LCD_Write_CText_At(2,1," 100 x 40 = 4sec");
 Delay_ms(2000);



 Cnt3=100;
 UART1_Write_CText("\r\nTest duree Timer3 initialis  100x40mS ,soit 4sec\r\n");
 GIE_bit = 1;
 IPEN_bit=1;
 PEIE_bit = 1;
 Arme_Elapsed_Timer3();
 CRLF1();
 UART1_Write('*');
 CRLF1();
 while(Elapsed_Tmr3==0);
 CRLF1();
 UART1_Write('#');
 CRLF1();
 GIE_bit = 0;


 Terminator=13;
 RAZ_UART1();
 UART1_Write_CText(" Init ADC1\r\n");
 Init_ADC();


 LCD_Write_CText_At(2,1,"Init ADC sur EA1");
 Delay_ms(2000);
#line 1180 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 UART1_Write_CText(" Arme IT UART1 & UART2\r\n");

 RAZ_UART1();
 RAZ_UART2();


 LCD_RAZ_Ligne(2);
 LCD_Write_CText_At(1,1,"Arme Interrupts ");
 Delay_ms(1500);



 RC1IE_bit = 1;
 RC2IE_bit = 1;
 PEIE_bit = 1;
 GIE_bit = 1;
 IPEN_bit=1;
 Flag_Timer0=0;
 Terminator=13;
#line 1213 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 RAZ_UART1();
 RAZ_UART2();

 Terminator=13;
 do
 {
 Cnt3=105;
 Arme_Elapsed_Timer3();
 txt=&TEXTE[0];


 strConstRamCpy( txt,"BP1=    ;BP2=     ; EA1= ");
 *(txt+4)=BP1+48;
 *(txt+13)=BP2+48;
 EA1=ADC_Read(1);
 WordToStr(EA1,CRam1);
 strcat(txt,CRam1);
 UART1_Write_Text(txt);
 CRLF1();


 LCD_CLS();
 txt=&TEXTE[0];
 strConstRamCpy( txt,"B1=. B2=. ");
 *(txt+3)=BP1+48; *(txt+8)=BP2+48;
 WordToStr(EA1,CRam1);
 strcat(txt,CRam1);
 LCD_Write_Text_At(1,1,txt);
 LCD_Write_CText_At(2,1,"Date :          ");
 LCD_Write_Text_At( 2,8,Date);
 Delay_ms(500);








 while((Elapsed_Tmr3==0) && ( UART2_DataReady<2)) ;

 if( UART2_DataReady==2)
 {
#line 1262 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 strConstRamCpy(CRam1,"$GPRMC,");
 if(strncmp(&Trame_RMC[0],CRam1,7) == 0)
 {
 Recupere_Date_RMC();
 }
 else
 UART1_Write_CText("BAD Reception ou Decodage GGA\r\n");

 strConstRamCpy(CRam1,"$GPGGA,");
 if(strncmp(&Trame_GGA[0],CRam1,7) == 0) ; UART1_Write(' ');
 {

 Flag_GPS=Decode_Trame_GPS_GPGGA();
 if (Flag_GPS==10)
 {
#line 1280 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Clicker2_18F87J50_GPS_COMPAS_UBLOX_7N_LCD_HID_160903.c"
 Display_Trame_On_Terminal();

 Display_Trame_On_LCD();

 }
 else
 UART1_Write_CText("BAD Reception ou Decodage GGA\r\n");
 }
 }
 if ( UART1_DataReady==1)
 {
 RAZ_UART2();
 UART1_Write_CText("UART1 Recu : ");
 UART1_Write_Text(buffer1);
 CRLF1();

 LCD_CLS();
 strncpy(CRam1,buffer1,16);
 LCD_Write_CText_At(1,1,"UART1 Recu : ");
 LCD_Write_Text_At(2,1,CRam1);
 Delay_ms(1000);

 if (strncmp(&buffer1[0],"Cde=",4)==0)
 {

 UART2_Write_Text(buffer1+4);
 }
 RAZ_UART1();
 }
 RAZ_UART2();
 }
 while(1);
}
